--- system-config-date -original.docs.ca.po	2009-05-25 17:57:33.000000000 +0200
+++ system-config-date.docs.ca.po	2009-05-27 19:44:59.000000000 +0200
@@ -1,32 +1,36 @@
+# Judith Pinto Subirada <judithp@gmail.com>, 2009.
+# 
+# 
 msgid ""
 msgstr ""
-"Project-Id-Version: PACKAGE VERSION\n"
+"Project-Id-Version: system-config-date VERSION\n"
+"Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2008-03-12 11:08+0100\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: LANGUAGE <LL@li.org>\n"
+"PO-Revision-Date: 2009-05-27 19:44+0200\n"
+"Last-Translator: Judith Pintó Subirada <judithp@gmail.com>\n"
+"Language-Team: Catalan <fedora@softcatala.net>\n"
 "MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
+"Content-Type: text/plain; charset=\n"
+"Content-Transfer-Encoding: "
 
 #. When image changes, this message will be marked fuzzy or untranslated for you.
 #. It doesn't matter what you translate it to: it's not used at all.
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:166(None)
 msgid "@@image: 'images/date-time.png'; md5=5e1cbe9fcdb6322a27e929f1fa941b68"
-msgstr ""
+msgstr "res"
 
 #. When image changes, this message will be marked fuzzy or untranslated for you.
 #. It doesn't matter what you translate it to: it's not used at all.
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:215(None)
 msgid ""
 "@@image: 'images/date-time-ntp.png'; md5=f34de73a771f99334204cdd6419dc7e0"
-msgstr ""
+msgstr "res"
 
 #. When image changes, this message will be marked fuzzy or untranslated for you.
 #. It doesn't matter what you translate it to: it's not used at all.
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:254(None)
 msgid "@@image: 'images/timezone.png'; md5=22fe7e3155978df6b828a8ea6744cfe3"
-msgstr ""
+msgstr "res"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:51(title)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:100(see)
@@ -34,55 +38,55 @@
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:120(see)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:125(see)
 msgid "Time and Date Properties Tool"
-msgstr ""
+msgstr "Eina de propietats de data i hora"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:57(revnumber)
 msgid "1.0"
-msgstr ""
+msgstr "1.0"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:58(date)
 msgid "2007-11-22"
-msgstr ""
+msgstr "22/11/2007"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:59(revremark)
 msgid "Initial revision"
-msgstr ""
+msgstr "Revisió inicial"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:62(revnumber)
 msgid "1.0.1"
-msgstr ""
+msgstr "1.0.1"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:63(date)
 msgid "2008-01-17"
-msgstr ""
+msgstr "17/01/2008"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:64(revremark)
 msgid "Make DocBook XML validate properly"
-msgstr ""
+msgstr "Feu que DocBook XML validi correctament"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:67(revnumber)
 msgid "1.0.2"
-msgstr ""
+msgstr "1.0.2"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:68(date)
 msgid "2008-01-18"
-msgstr ""
+msgstr "18/01/2008"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:69(revremark)
 msgid "Make document abstract external"
-msgstr ""
+msgstr "Feu extern el document de resum"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:72(revnumber)
 msgid "1.0.3"
-msgstr ""
+msgstr "1.0.3"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:73(date)
 msgid "2008-03-12"
-msgstr ""
+msgstr "12/03/2008"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:74(revremark)
 msgid "Use menuchoice elements where applicable"
-msgstr ""
+msgstr "Utilitzeu elements de tria de menu on siguin d'aplicació"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:79(para)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:103(para)
@@ -91,38 +95,38 @@
 "to change the system date and time, to configure the time zone used by the "
 "system, and to setup the Network Time Protocol (NTP) daemon to synchronize "
 "the system clock with a time server."
-msgstr ""
+msgstr "L'<application>eina de propietats de data i hora</application>permet a l'usuari canviar la data i l'hora del sistema, per a configurar la zona horària que utilitzarà el sistema, i definir el dimoni del protocol del servidor de temps (NTP) per a sincronitzar el rellotge del sistema amb el servidor de temps."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:91(trademark)
 msgid "Red Hat"
-msgstr ""
+msgstr "Red Hat"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:90(corpauthor)
 msgid "<placeholder-1/>, Inc."
-msgstr ""
+msgstr "<placeholder-1/>, S.A."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:98(command)
 msgid "timetool"
-msgstr ""
+msgstr "timetool"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:113(command)
 msgid "system-config-date"
-msgstr ""
+msgstr "system-config-date"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:118(command)
 msgid "system-config-time"
-msgstr ""
+msgstr "system-config-time"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:123(command)
 msgid "dateconfig"
-msgstr ""
+msgstr "dateconfig"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:128(para)
 msgid ""
 "You must be running the <application>X</application> Window System and have "
 "root privileges to use the Time and Date Properties Tool. There are three "
 "ways to start the application:"
-msgstr ""
+msgstr "Heu d'arrancar el sistema de finestres <application>X</application> i tenir privilegis de root per a utilitzar l'eina de propietats de data i hora. Existeixen tres opcions per a engegar l'aplicació"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:133(para)
 msgid ""
@@ -130,13 +134,13 @@
 "menu with the \"f\" icon)</guimenu><guisubmenu>System</"
 "guisubmenu><guisubmenu>Administration</guisubmenu><guimenuitem>Date &amp; "
 "Time</guimenuitem></menuchoice>"
-msgstr ""
+msgstr "Des de l'escriptori vés a <menuchoice><guimenu>el menú principal del panell (el menú amb l'icona \"f\")</guimenu><guisubmenu>Sistema</guisubmenu><guisubmenu>Administració</guisubmenu><guimenuitem>Data i hora</guimenuitem></menuchoice>"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:139(para)
 msgid ""
 "From the desktop, right-click on the time in the toolbar and select "
 "<guimenuitem>Adjust Date and Time</guimenuitem>."
-msgstr ""
+msgstr "Des de l'escriptori, fés click amb el botó dret del ratolí sobre l'hora a la barra d'eines i selecciona <guimenuitem>Ajusta la data i l'hora</guimenuitem>."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:145(para)
 msgid ""
@@ -144,42 +148,42 @@
 "config-time</command>, or <command>dateconfig</command> at a shell prompt "
 "(for example, in an <application>XTerm</application> or a "
 "<application>GNOME</application> terminal)."
-msgstr ""
+msgstr "Teclejeu l'ordre <command>system-config-date</command>, <command>system-config-time</command>, o <command>dateconfig</command> a l'intèrpret d'ordres (per exemple, en un <application>XTerm</application> o en una consola de <application>GNOME</application>)."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:153(title)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:163(title)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:167(para)
 msgid "Time and Date Properties"
-msgstr ""
+msgstr "Propietats de data i hora"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:155(primary)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:189(primary)
 msgid "time configuration"
-msgstr ""
+msgstr "time configuration"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:158(primary)
 msgid "date configuration"
-msgstr ""
+msgstr "date configuration"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:160(para)
 msgid ""
 "As shown in <xref linkend=\"dateconfig-time-date\"/>, the first tabbed "
 "window that appears is for configuring the system date and time."
-msgstr ""
+msgstr "Tal com es mostra a <xref linkend=\"dateconfig-time-date\"/>, la primera finestra amb pestanyes que apareix és per a configurar l'hora i la data del sistema."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:173(para)
 msgid ""
 "To change the date, use the arrows to the left and right of the month to "
 "change the month, use the arrows to the left and right of the year to change "
 "the year, and click on the day of the week to change the day of the week."
-msgstr ""
+msgstr "Per a canviar la data utilitza les fletxes cap a l'esquerra i la dreta del mes per a canviar el mes, utilitza les fletxes cap a l'esquerra i cap a la dreta de l'any per a canviar l'any i clica sobre el dia de la setmana per a canviar el dia de la setmana."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:177(para)
 msgid ""
 "To change the time, use the up and down arrow buttons beside the "
 "<guilabel>Hour</guilabel>, <guilabel>Minute</guilabel>, and "
 "<guilabel>Second</guilabel> in the <guilabel>Time</guilabel> section."
-msgstr ""
+msgstr "Per a canviar l'hora, utilitza els botons de les fletxes d'amunt i avall que estan al costat de l'<guilabel>Hour</guilabel>, <guilabel>Minute</guilabel>, i<guilabel>Second</guilabel> a la secció de l'<guilabel>Time</guilabel>."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:182(para)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:227(para)
@@ -187,45 +191,45 @@
 "Clicking the <guibutton>OK</guibutton> button applies any changes made to "
 "the date and time, the NTP daemon settings, and the time zone settings. It "
 "also exits the program."
-msgstr ""
+msgstr "Clicant el botó <guibutton>OK</guibutton> s'aplicaran els canvis sobre l'hora i la data, la configuració del dimoni NTP i la configuració de la zona horària. També se sortirà del programa."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:187(title)
 msgid "Network Time Protocol (NTP) Properties"
-msgstr ""
+msgstr "Propietats del protocol de temps de xarxa (NTP)"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:190(secondary)
 msgid "synchronize with NTP server"
-msgstr ""
+msgstr "sincronitza amb el servidor NTP"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:193(primary)
 msgid "Network Time Protocol"
-msgstr ""
+msgstr "Protocol de temps de xarxa"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:194(see)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:197(primary)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:201(primary)
 msgid "NTP"
-msgstr ""
+msgstr "NTP"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:198(secondary)
 msgid "configuring"
-msgstr ""
+msgstr "configurant"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:202(command)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:206(command)
 msgid "ntpd"
-msgstr ""
+msgstr "ntpd"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:209(para)
 msgid ""
 "As shown in <xref linkend=\"dateconfig-ntp\"/>, the second tabbed window "
 "that appears is for configuring NTP."
-msgstr ""
+msgstr "Tal com es mostra a <xref linkend=\"dateconfig-ntp\"/>, la segona finestra de pestanyes que apareix és per a configurar el NTP."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:212(title)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:216(para)
 msgid "NTP Properties"
-msgstr ""
+msgstr "Propietats de NTP"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:222(para)
 msgid ""
@@ -240,21 +244,21 @@
 "synchronizing with the NTP server until you click <guibutton>OK</guibutton>. "
 "After clicking <guibutton>OK</guibutton>, the configuration is saved and the "
 "NTP daemon is started (or restarted if it is already running)."
-msgstr ""
+msgstr "El dimoni del protocol de temps de xarxa (NTP) sincronitza el rellotge del sistema amb un servidor de temps remot o font de temps. L'aplicació permet configurar un dimoni NTP per a que el rellotge del sistema se sincronitzi amb un servidor remot. Per a activar aquesta característica, selecciona  <guibutton>Habilita el protocol de temps de xarxa</guibutton>. Això habilita la llista de <guilabel>Servidors NTP</guilabel> i altres opcions. Es pot escollir un dels servidors predefinits, editar-lo fent click al botó <guibutton>Edita</guibutton> o afegir-ne un de nou clicant <guibutton>Afegeix</guibutton>. El sistema no comença a sincronitzar-se amb el servidor NTP fins que no es clica <guibutton>OK</guibutton>. Després de clicar <guibutton>D'acord</guibutton>, la configuració es guarda i el dimoni NTP s'inicia (o es reinicia si ja estava executant)."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:232(title)
 msgid "Time Zone Configuration"
-msgstr ""
+msgstr "Configuració de la zona horària"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:234(primary)
 msgid "time zone configuration"
-msgstr ""
+msgstr "configuració de la zona horària"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:236(para)
 msgid ""
 "As shown in <xref linkend=\"dateconfig-timezone\"/>, the third tabbed window "
 "that appears is for configuring the system time zone."
-msgstr ""
+msgstr "Tal com es mostra a <xref linkend=\"dateconfig-timezone\"/>, la tercera pestanya de la finestra que apareix és per a configurar la zona horària del sistema."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:240(para)
 msgid ""
@@ -265,7 +269,7 @@
 "<guilabel>X</guilabel> appears and the time zone selection changes in the "
 "list below the map. You can use the slider to the left of the map to change "
 "the zoom level."
-msgstr ""
+msgstr "Per a configurar la zona horària del sistema, clica la pestanya de <guilabel>Fus horari</guilabel>. La zona horària es pot canviar utilitzant el mapa interactiu o bé triant la zona horària desitjada de la llista que apareix sota el mapa. Per a utilitzar el mapa cliqueu-hi per a seleccionar la ciutat adient a la vostra zona horària. Una <guilabel>X</guilabel> vermella apareixerà i la selecció de la zona horària canvia a la llista sota el mapa. Podeu utilitzar el botó lliscant cap a l'esquerra del mapa per a canviar el nivell de zoom."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:243(para)
 msgid ""
@@ -274,17 +278,17 @@
 "zones is now a treelist, with cities and countries grouped within their "
 "specific continents. Non-geographic time zones have also been added to "
 "address needs in the scientific community."
-msgstr ""
+msgstr "Alternativament, també podeu utilitzar la llista de sota el mapa. De la mateixa manera que el mapa us permet triar la regió abans d'escollir la ciutat, la llista de zones horàries és ara una llista en forma d'arbre, amb ciutats i països agrupats dins els seus continents. Les zones horàries no geogràfiques també s'han afegit per a satisfer les necessitats de la comunitat científica."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:247(para)
 msgid ""
 "Click <guibutton>OK</guibutton> to apply the changes and exit the program."
-msgstr ""
+msgstr "Cliqueu <guibutton>D'acord</guibutton> per a fer efectius els canvis i sortir del programa."
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:251(title)
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:255(para)
 msgid "Timezone Properties"
-msgstr ""
+msgstr "Propietats de la zona horària"
 
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:261(para)
 msgid ""
@@ -292,9 +296,10 @@
 "uses UTC</guibutton> option. UTC stands for the <firstterm>Universal Time, "
 "Coordinated</firstterm>, also known as Greenwich Mean Time (GMT). Other time "
 "zones are determined by adding or subtracting from the UTC time."
-msgstr ""
+msgstr "Si el rellotge del sistema està fixat per a utilitzar UTC, seleccioneu l'opció <guibutton>El rellotge del sistema fa servir UTC</guibutton>. UTC significa <firstterm>Universal Time, Coordinated</firstterm>, també conegut com a Greenwich Mean Time (GMT). Altres zones horàries es determinen sumant o restant des de l'hora UTC."
 
 #. Put one translator per line, in the form of NAME <EMAIL>, YEAR1, YEAR2.
 #: /home/nils/src/system-config-date/hosted/doc/C/system-config-date-complete.xml:0(None)
 msgid "translator-credits"
-msgstr ""
+msgstr "translator-credits"
+