--- libvirt.HEAD.fr.old3.po	2010-08-03 19:28:56.000000000 +0200
+++ libvirt.HEAD.fr.po	2010-08-03 19:41:40.000000000 +0200
@@ -14,7 +14,7 @@
 "Project-Id-Version: libvirt.HEAD.fr-4\n"
 "Report-Msgid-Bugs-To: libvir-list@redhat.com\n"
 "POT-Creation-Date: 2010-07-05 17:00+0200\n"
-"PO-Revision-Date: 2010-08-03 19:31+0200\n"
+"PO-Revision-Date: 2010-08-03 19:44+0200\n"
 "Last-Translator: Boris BARNIER <b.barnier@gmail.com>\n"
 "Language-Team: French <trans-fr@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
@@ -211,11 +211,11 @@
 #: src/remote/remote_driver.c:8881 src/test/test_driver.c:514
 #: src/test/test_driver.c:758 src/xen/xen_driver.c:302
 msgid "cannot initialize mutex"
-msgstr "impossible d'initialiser le mutex"
+msgstr "Impossible d'initialiser le mutex"
 
 #: daemon/libvirtd.c:852
 msgid "cannot initialize condition variable"
-msgstr "impossible d'initialiser la variable condition"
+msgstr "Impossible d'initialiser la variable condition"
 
 #: daemon/libvirtd.c:859
 msgid "Failed to initialize event system"
@@ -295,7 +295,7 @@
 
 #: daemon/libvirtd.c:1220
 msgid "remoteCheckCertificate: the client certificate is not yet activated"
-msgstr "remoteCheckCertificate : le certificat du client n'est pas encore activé."
+msgstr "remoteCheckCertificate : le certificat du client n'est pas valide."
 
 #: daemon/libvirtd.c:1229
 msgid ""
@@ -312,7 +312,7 @@
 #: daemon/libvirtd.c:1247
 msgid "remoteCheckCertificate: failed to verify client's certificate"
 msgstr ""
-"remoteCheckCertificate : la vérification du certificat du client a échoué."
+"remoteCheckCertificate : la vérification du certificat du client a échouée."
 
 #: daemon/libvirtd.c:1250
 msgid ""
@@ -377,7 +377,7 @@
 #: daemon/libvirtd.c:1717
 #, c-format
 msgid "failed to decode SASL data %s"
-msgstr "impossible de décoder les données SASL %s"
+msgstr "Impossible de décoder les données SASL %s"
 
 #: daemon/libvirtd.c:1887
 #, c-format
@@ -392,7 +392,7 @@
 #: daemon/libvirtd.c:1947
 #, c-format
 msgid "failed to encode SASL data %s"
-msgstr "impossible d'encoder les données SASL %s"
+msgstr "Impossible d'encoder les données SASL %s"
 
 #: daemon/libvirtd.c:2223
 #, c-format
@@ -411,7 +411,7 @@
 #: daemon/libvirtd.c:2483 daemon/libvirtd.c:2502
 #, c-format
 msgid "failed to allocate memory for %s config list"
-msgstr "impossible d'allouer de la mémoire pour la liste de configuration %s"
+msgstr "Impossible d'allouer de la mémoire pour la liste de configuration %s"
 
 #: daemon/libvirtd.c:2489 daemon/libvirtd.c:2519
 #, c-format
@@ -472,7 +472,7 @@
 
 #: daemon/libvirtd.c:2912
 msgid "failed to set reduced privileges"
-msgstr "impossible de définir les privilèges restreints"
+msgstr "Impossible de définir les privilèges restreints"
 
 #: daemon/libvirtd.c:2945
 #, c-format
@@ -566,7 +566,7 @@
 #: daemon/libvirtd.c:3061
 #, c-format
 msgid "%s: initialization failed\n"
-msgstr "%s : l'initialisation a échoué\n"
+msgstr "%s : l'initialisation a échouée\n"
 
 #: daemon/libvirtd.c:3115
 #, c-format
@@ -589,11 +589,11 @@
 
 #: daemon/libvirtd.c:3242
 msgid "Driver state initialization failed"
-msgstr "L'initialisation de l'état du pilote a échoué"
+msgstr "L'initialisation de l'état du pilote a échouée"
 
 #: daemon/libvirtd.c:3249
 msgid "Network event loop enablement failed"
-msgstr "L'activation de la boucle locale a échoué"
+msgstr "L'activation de la boucle locale a échouée"
 
 #: daemon/remote.c:387
 msgid "connection already open"
@@ -691,31 +691,31 @@
 
 #: daemon/remote.c:3367
 msgid "cannot get TLS cipher size"
-msgstr "impossible d'obtenir la taille du chiffrement TLS"
+msgstr "Impossible d'obtenir la taille du chiffrement TLS"
 
 #: daemon/remote.c:3376
 #, c-format
 msgid "cannot set SASL external SSF %d (%s)"
-msgstr "impossible de définir le SSF externe SASL %d (%s)"
+msgstr "Impossible de définir le SSF externe SASL %d (%s)"
 
 #: daemon/remote.c:3404
 #, c-format
 msgid "cannot set SASL security props %d (%s)"
-msgstr "impossible de définir les propriétés de sécurité SASL %d (%s)"
+msgstr "Impossible de définir les propriétés de sécurité SASL %d (%s)"
 
 #: daemon/remote.c:3420
 #, c-format
 msgid "cannot list SASL mechanisms %d (%s)"
-msgstr "impossible de lister les mécanismes SASL %d (%s)"
+msgstr "Impossible de lister les mécanismes SASL %d (%s)"
 
 #: daemon/remote.c:3429
 msgid "cannot allocate mechlist"
-msgstr "impossible d'allouer la liste des mécanismes"
+msgstr "Impossible d'allouer la liste des mécanismes"
 
 #: daemon/remote.c:3460 src/remote/remote_driver.c:7164
 #, c-format
 msgid "cannot query SASL ssf on connection %d (%s)"
-msgstr "impossible d'envoyer une requête SSF SASL lors de la connexion %d (%s)"
+msgstr "Impossible d'envoyer une requête SSF SASL lors de la connexion %d (%s)"
 
 #: daemon/remote.c:3470
 #, c-format
@@ -726,7 +726,7 @@
 #, c-format
 msgid "cannot query SASL username on connection %d (%s)"
 msgstr ""
-"impossible d'envoyer une requête nom d'utilisateur SASL lors de la connexion "
+"Impossible d'envoyer une requête nom d'utilisateur SASL lors de la connexion "
 "%d (%s)"
 
 #: daemon/remote.c:3507
@@ -785,7 +785,7 @@
 
 #: daemon/remote.c:3809 daemon/remote.c:3878
 msgid "cannot get peer socket identity"
-msgstr "impossible d'obtenir l'identité du connecteur réseau du pair"
+msgstr "Impossible d'obtenir l'identité du connecteur réseau du pair"
 
 #: daemon/remote.c:3813 daemon/remote.c:3882
 #, c-format
@@ -815,7 +815,7 @@
 #: daemon/remote.c:3886
 #, c-format
 msgid "Failed to lookup policy kit caller: %s"
-msgstr "La recherche de l'appelant de PolicyKit a échoué : %s"
+msgstr "La recherche de l'appelant de PolicyKit a échouée : %s"
 
 #: daemon/remote.c:3893
 #, c-format
@@ -909,11 +909,11 @@
 
 #: src/conf/cpu_conf.c:144
 msgid "Missing match attribute for CPU specification"
-msgstr "L'attribut match est manquant pour la spécification CPU"
+msgstr "L'attribut « match » est manquant pour la spécification CPU"
 
 #: src/conf/cpu_conf.c:154
 msgid "Invalid match attribute for CPU specification"
-msgstr "Attribut match invalide pour la spécification CPU"
+msgstr "Attribut « match » invalide pour la spécification CPU"
 
 #: src/conf/cpu_conf.c:164
 msgid "Missing CPU architecture"
@@ -937,7 +937,7 @@
 
 #: src/conf/cpu_conf.c:209
 msgid "Invalid CPU topology"
-msgstr "Élement CPU topology invalide"
+msgstr "Élement « CPU topology » invalide"
 
 #: src/conf/cpu_conf.c:221 src/conf/cpu_conf.c:327
 msgid "Non-empty feature list specified without CPU model"
@@ -945,11 +945,11 @@
 
 #: src/conf/cpu_conf.c:244
 msgid "Invalid CPU feature policy"
-msgstr "Élement CPU feature policy invalide"
+msgstr "Élement « CPU feature policy » invalide"
 
 #: src/conf/cpu_conf.c:254
 msgid "Invalid CPU feature name"
-msgstr "Élement CPU feature name invalide"
+msgstr "Élement « CPU feature name » invalide"
 
 #: src/conf/cpu_conf.c:261 src/conf/cpu_conf.c:404
 #, c-format
@@ -959,16 +959,16 @@
 #: src/conf/cpu_conf.c:336
 #, c-format
 msgid "Unexpected CPU match policy %d"
-msgstr "Élement CPU match policy %d inattendu"
+msgstr "Élement « CPU match policy » %d inattendu"
 
 #: src/conf/cpu_conf.c:365 src/cpu/cpu_x86.c:388
 msgid "Missing CPU feature name"
-msgstr "Élement CPU feature name manquant"
+msgstr "Élement « CPU feature name » manquant"
 
 #: src/conf/cpu_conf.c:375
 #, c-format
 msgid "Unexpected CPU feature policy %d"
-msgstr "Élement CPU feature policy %d inattendu"
+msgstr "Élement « CPU feature policy » %d inattendu"
 
 #: src/conf/domain_conf.c:1030
 msgid "missing device information"