From 7f9a9f7b2ee277f62b5e847dc131276549e2297f Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Thu, 18 Feb 2010 14:43:39 -0500
Subject: [PATCH 5/5] Properly license libdhash

---
 common/dhash/dhash.c         |   24 ++++++++++++++++++++++++
 common/dhash/dhash.h         |   24 ++++++++++++++++++++++++
 common/dhash/dhash_example.c |   20 ++++++++++++++++++++
 common/dhash/dhash_test.c    |   20 ++++++++++++++++++++
 4 files changed, 88 insertions(+), 0 deletions(-)

diff --git a/common/dhash/dhash.c b/common/dhash/dhash.c
index fb024c8..cb292b7 100644
--- a/common/dhash/dhash.c
+++ b/common/dhash/dhash.c
@@ -1,3 +1,27 @@
+/*
+    Authors:
+        John Dennis <jdennis.redhat.com>
+        Esmond Pitt <ejp@ausmelb.oz.AU>
+
+    This implementation was based on a 3/7/1989 public domain submission
+    to comp.sources.misc by Esmond Pitt <ejp@ausmelb.oz.AU>.
+
+    Copyright (C) 2009 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 /*****************************************************************************/
 /******************************** Documentation ******************************/
 /*****************************************************************************/
diff --git a/common/dhash/dhash.h b/common/dhash/dhash.h
index 47f9673..966b15c 100644
--- a/common/dhash/dhash.h
+++ b/common/dhash/dhash.h
@@ -1,3 +1,27 @@
+/*
+    Authors:
+        John Dennis <jdennis.redhat.com>
+        Esmond Pitt <ejp@ausmelb.oz.AU>
+
+    This implementation was based on a 3/7/1989 public domain submission
+    to comp.sources.misc by Esmond Pitt <ejp@ausmelb.oz.AU>.
+
+    Copyright (C) 2009 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #ifndef DHASH_H
 #define DHASH_H
 
diff --git a/common/dhash/dhash_example.c b/common/dhash/dhash_example.c
index 7ed01d7..bd0ca8e 100644
--- a/common/dhash/dhash_example.c
+++ b/common/dhash/dhash_example.c
@@ -1,3 +1,23 @@
+/*
+    Authors:
+        John Dennis <jdennis.redhat.com>
+
+    Copyright (C) 2009 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
diff --git a/common/dhash/dhash_test.c b/common/dhash/dhash_test.c
index 27eb88d..e5b922d 100644
--- a/common/dhash/dhash_test.c
+++ b/common/dhash/dhash_test.c
@@ -1,3 +1,23 @@
+/*
+    Authors:
+        John Dennis <jdennis.redhat.com>
+
+    Copyright (C) 2009 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #include <stdio.h>
 #include <assert.h>
 #include <string.h>
-- 
1.6.6